SystemOrganization addCategory: #Project!

Object subclass: #DidaticStructure
	instanceVariableNames: 'id name creator ownerList visible topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!DidaticStructure commentStamp: 'RFG 5/11/2013 13:53' prior: 0!
Mudar o nome dessa classe. It represents: Lecture U Group U Subject U Courses!

DidaticStructure subclass: #Course
	instanceVariableNames: 'subjectList userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Course commentStamp: 'RFG 5/2/2013 11:43' prior: 0!
Represents a course in the system.!

!Course methodsFor: 'inclusion' stamp: 'RFG 5/11/2013 15:43'!
addUser: ID
	"comment stating purpose of message"

	userList add: ID! !

!Course methodsFor: 'remotion' stamp: 'RFG 5/11/2013 15:42'!
removeUser: ID.
	"Removes the user with the given ID."
	
	userList remove: ID! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 09:58'!
subjectList
	"Returns the list of subjects included in the course."

	^subjectList.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 09:58'!
subjectList: aListOfIDs
	"Sets the list of subjects included in the course."

	subjectList := aListOfIDs.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:36'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Course methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:21'!
userList: aListOfIDs
	"Sets the list of inscribed users."

	userList := aListOfIDs.! !

!DidaticStructure class methodsFor: 'instance creation' stamp: 'AP 5/11/2013 16:21'!
newWithID: anID named: aString by: anUserID
	"Creates a new DidaticStructure with an ID, named aString and the creator indicated by anUserID."

	| newDidaticStructure |
	
	newDidaticStructure := self new.
	
	newDidaticStructure id: anID.
	newDidaticStructure name: aString.
	newDidaticStructure creator: anUserID.
	newDidaticStructure visible: false. 
	
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	
	^newDidaticStructure.! !

!DidaticStructure class methodsFor: 'instance creation' stamp: 'RFG 5/11/2013 14:30'!
newWithID: anID named: aString by: anUserID onTopic: aTopicID
	"Creates a new DidaticStructure with an ID, named aString and the creator indicated by anUserID."

	| newDidaticStructure |
	
	newDidaticStructure := self new.
	
	newDidaticStructure id: anID.
	newDidaticStructure name: aString.
	newDidaticStructure creator: anUserID.
	newDidaticStructure topic: aTopicID.
	newDidaticStructure visible: False. 
	
	newDidaticStructure ownerList isNil
		ifTrue: [newDidaticStructure ownerList: OrderedCollection new].
	
	^newDidaticStructure.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:03'!
creator
	"Returns the creator."

	^creator.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:22'!
creator: anID
	"Sets the ID of the creator."

	creator := anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:13'!
id
	"Returns the id."

	^id.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:12'!
id: anID
	"Sets the id."

	id := anID.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:13'!
name
	"Returns the name."

	^name.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/10/2013 18:14'!
name: aString
	"Sets the name."

	name := aString.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:07'!
ownerList
	"Returns the list of owners."

	^ownerList.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 08:06'!
ownerList: aListOfIDs
	"Sets the list of owners."

	ownerList := aListOfIDs.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic
	"Returns the topic."

	^topic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 14:26'!
topic: aTopic
	"Sets the topic."

	topic := aTopic.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:01'!
visible
	"Returns whether the structure is visible or not by non-owners users"

	^visible.! !

!DidaticStructure methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:03'!
visible: boolean
	"Sets whether the structure is visible or not by non-owners users"

	visible := boolean.! !

DidaticStructure subclass: #Group
	instanceVariableNames: 'userList instructor subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Group commentStamp: 'RFG 5/9/2013 13:46' prior: 0!
Represents a group in the system. Set of students at inscribed in a subject with a instructor.!

!Group class methodsFor: 'instance creation' stamp: 'RFG 5/11/2013 11:32'!
newWithID: anID named: aString by: anUserID onSubject:  anSubjectID andInstructor: anInstructorID
	"Creates a new Group in a Subject and a instructor"
	
	| newGroup |
	
	newGroup := self newWithID: anID named: aString by: anUserID.
	newGroup instructor: anInstructorID.
	newGroup subject: anSubjectID.
	
	newGroup userList isNil
		ifTrue: [newGroup subjectList: OrderedCollection new].
	
	! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
instructor
	"Returns the group's instructor."

	^instructor.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
instructor: anUserID
	"Sets the group's instructor."

	instructor := anUserID.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:10'!
subject
	"Returns the group's subject."

	^subject.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:14'!
subject: anSubjectID
	"Sets the group's subject."

	subject := anSubjectID.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:54'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Group methodsFor: 'accessing' stamp: 'RFG 5/11/2013 10:54'!
userList: aListOfIDs
	"Sets the list of inscribed users."

	userList := aListOfIDs.! !

DidaticStructure subclass: #Lecture
	instanceVariableNames: 'subject userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Lecture commentStamp: 'RFG 5/10/2013 18:02' prior: 0!
Represents a Lecture of a Subject!

!Lecture class methodsFor: 'instance creation' stamp: 'RFG 5/11/2013 11:52'!
newWithID: anID named: aString by: anUserID onSubject:  anSubjectID 
	"Creates a new Lecture in a Subject"

	| newLecture |
	
	newLecture := self newWithID: anID named: aString by: anUserID.
	newLecture subject: anSubjectID.
	
	newLecture userList isNil
		ifTrue: [Lecture subjectList: OrderedCollection new].! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
subject
	"Returns the lecture's subject."

	^subject.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:40'!
subject: anSubjectID
	"Sets the lecture's subject."

	subject := anSubjectID.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:43'!
userList
	"Returns the list of inscribed users."

	^userList.! !

!Lecture methodsFor: 'accessing' stamp: 'RFG 5/11/2013 11:44'!
userList: aListOfIDs
	"Sets the list of inscribed users."

	userList := aListOfIDs.! !

DidaticStructure subclass: #Subject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Subject commentStamp: 'RFG 5/6/2013 15:55' prior: 0!
Represents a Subject in the system.!

DidaticStructure subclass: #Topic
	instanceVariableNames: 'courseTable subjectTable moderatorList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Topic commentStamp: 'RFG 5/2/2013 13:44' prior: 0!
Represents a topic in the system.!

!Topic class methodsFor: 'instance creation' stamp: 'AP 5/11/2013 15:51'!
newNamed: aName withID: anID creator: anUserID
	"Creates a new topic with the given name and id."
	
	|newTopic|
	
	newTopic := super newWithID: anID named: aName by: anUserID .
	
	newTopic courseTable isNil
		ifTrue: [newTopic courseTable: Dictionary new].
		
	newTopic subjectTable isNil
		ifTrue: [newTopic subjectTable: Dictionary new].
	
	newTopic moderatorList isNil
		ifTrue: [newTopic moderatorList: OrderedCollection new].
	
	^newTopic.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:16'!
courseTable
	"Returns the dictionary of courses of the topic."

	^courseTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:17'!
courseTable: aDictionary
	"Sets the dictionary of courses of the topic."

	courseTable := aDictionary.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/5/2013 08:50'!
creator
	"Returns the topic creator."

	^creator.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/5/2013 08:49'!
creator: anUserID.
	"Sets the topic creator."

	creator := anUserID.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:12'!
id
	"Returns the topic id."

	^id.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:12'!
id: anID
	"Sets the topic id."

	id := anID.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:44'!
moderatorList
	"Returns the list of moderators of the topic."

	^moderatorList.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:43'!
moderatorList: anOrderedCollection
	"Sets the list of moderators of the topic."

	moderatorList := anOrderedCollection.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name
	"Returns the topic name."

	^name.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 11:15'!
name: aName.
	"Sets the topic name."

	name := aName.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:42'!
subjectTable
	"Returns the dictionary of subjects of the topic."

	^subjectTable.! !

!Topic methodsFor: 'accessing' stamp: 'RFG 5/4/2013 15:41'!
subjectTable: aDictionary
	"Sets the dictionary of subjects of the topic."

	subjectTable := aDictionary.! !

Object subclass: #System
	instanceVariableNames: ''
	classVariableNames: 'ThisS TopicTable TopicToBeAproved UserTable'
	poolDictionaries: ''
	category: 'Project'!

!System commentStamp: 'RFG 5/2/2013 13:21' prior: 0!
The main class representing the own system.!

!System class methodsFor: 'initialization' stamp: 'AP 5/11/2013 16:28'!
create
	"Creates an empty system."
	
	ThisS isNil
		ifTrue: [
			ThisS := self new.
			TopicTable := Dictionary new.
			UserTable := Dictionary new.
			TopicToBeAproved := OrderedCollection new.
			].
		^ThisS.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable
	"Returns the dictionary with all topics."

	^TopicTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:54'!
TopicTable: aDictionary
	"Sets the dictionary with all topics."

	TopicTable :=  aDictionary! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:17'!
UserTable
	"Returns the dictionary with all users."

	^UserTable.! !

!System methodsFor: 'accessing' stamp: 'RFG 5/3/2013 20:13'!
UserTable: aDictionary
	"Sets the system user table."

	UserTable := aDictionary.! !

!System methodsFor: 'adding' stamp: 'AP 5/11/2013 15:58'!
addTopic: aTopic

	TopicTable at: aTopic id put: aTopic.
	TopicToBeAproved addLast: aTopic id.! !

!System methodsFor: 'adding' stamp: 'AP 5/11/2013 11:49'!
addUser: anUser

	UserTable at: anUser id put: anUser  .! !

!System methodsFor: 'accessing' stamp: 'RFG 5/11/2013 16:35'!
findCourse: ID
	"Returns a course with the given ID."
	
	TopicTable keysAndValuesDo:  [:topicID :topic | 
		topic courseTable keysAndValuesDo: [ :courseID :course | 
			courseID == ID ifTrue: [^course]
			]
		]! !

!System methodsFor: 'accessing' stamp: 'RFG 5/11/2013 16:57'!
findSubject: ID
	"Returns a subject with the given ID."
	
	TopicTable keysAndValuesDo:  [:topicID :topic | 
		topic courseTable keysAndValuesDo: [ :subjectID :subject | 
			subjectID == ID ifTrue: [^subject]
			]
		]! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 16:25'!
findTopic: anID

	^TopicTable at: anID! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 12:18'!
findUser: anID

	^UserTable at: anID! !

!System methodsFor: 'removing' stamp: 'AP 5/11/2013 12:30'!
removeTopic: anID
	"Remove a Topic from the System"
	TopicTable removeKey: anID! !

!System methodsFor: 'removing' stamp: 'AP 5/11/2013 12:38'!
removeUser: anID
	"Remove an user from the System"
	UserTable removeKey: anID! !

!System methodsFor: 'accessing' stamp: 'AP 5/11/2013 16:01'!
topicToModerator

	^TopicToBeAproved at: 1! !

Object subclass: #User
	instanceVariableNames: 'id name courseList groupList contentList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!User commentStamp: 'RFG 5/2/2013 11:22' prior: 0!
Represents a user in the system.!

User subclass: #Moderator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Moderator commentStamp: 'RFG 5/11/2013 12:24' prior: 0!
Represents a topic moderator in the system.!

Moderator subclass: #Administrator
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Project'!

!Administrator commentStamp: 'RFG 5/11/2013 14:52' prior: 0!
Represents special users who can create topics and erase/create anything.!

!Administrator methodsFor: 'creation' stamp: 'AP 5/11/2013 13:01'!
createUser: aName withId: anID
	
	| newUser 
	  sys    |
	
	newUser := User id: anID name: aName.
	sys := System create.
	sys addUser: newUser.! !

!Moderator methodsFor: 'publishing' stamp: 'AP 5/11/2013 16:30'!
aproveTopic

	| anId
	  aTopic
	  sys	|
	
	sys := System create.
	anId := sys topicToModerator.
	aTopic := sys findTopic: anId.
	aTopic visible: true.
! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/11/2013 15:19'!
hide: aDidaticStructure of: system
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic |
	
	topic :=  system findTopic: aDidaticStructure topic.
	
	id in topic moderatorList
		ifTrue: [aDidaticStructure visible: False].
		! !

!Moderator methodsFor: 'publishing' stamp: 'RFG 5/11/2013 15:14'!
publish: aDidaticStructure on: system
	"Turns a didatic structure invisible to all commom users non-owners."

	| topic |
	
	topic :=  system findTopic: aDidaticStructure topic.
	
	id in topic moderatorList
		ifTrue: [aDidaticStructure visible: True].
		! !

!User class methodsFor: 'instance creation' stamp: 'AP 5/11/2013 12:50'!
id: anID name: aName
	"comment stating purpose of message"
	
	|newUser|
	newUser := self new.
	newUser id: anID.
	newUser name: aName.
	newUser groupList isNil
		ifTrue: [newUser groupList: OrderedCollection new].
	newUser courseList isNil
		ifTrue: [newUser courseList: OrderedCollection new].
	newUser contentList isNil
		ifTrue: [newUser contentList: OrderedCollection new].
	^newUser! !

!User methodsFor: 'getters' stamp: 'RFG 5/3/2013 16:31'!
contentList
	"Returns a list with the IDs of the Contents owned by the user."

	^contentList.! !

!User methodsFor: 'setters' stamp: 'RFG 5/3/2013 18:15'!
contentList: anOrderedCollection
	"Sets the user content list."

	contentList := anOrderedCollection.! !

!User methodsFor: 'getters' stamp: 'RFG 5/3/2013 16:39'!
courseList
	"comment stating purpose of message"

	^courseList.! !

!User methodsFor: 'setters' stamp: 'RFG 5/3/2013 18:19'!
courseList: anOrderedCollection
	"Sets the user content list."

	courseList := anOrderedCollection.! !

!User methodsFor: 'remotion' stamp: 'RFG 5/3/2013 18:52'!
delete.
	"Removes the user from the system."! !

!User methodsFor: 'remotion' stamp: 'RFG 5/11/2013 15:45'!
deleteFrom: system.
	"Removes the user from the system."
	
	
	
	! !

!User methodsFor: 'subscription' stamp: 'RFG 5/3/2013 16:49'!
enrollCourse: courseID
	"Enrolls the user in a course."

	courseList add: courseID.! !

!User methodsFor: 'subscription' stamp: 'RFG 5/3/2013 16:50'!
enterGroup: aGroupID
	"Makes the user part of the group with the given ID."! !

!User methodsFor: 'getters' stamp: 'RFG 5/3/2013 16:30'!
groupList
	"Returns a list with the IDs of the Groups which the user is in."

	^groupList.! !

!User methodsFor: 'setters' stamp: 'RFG 5/3/2013 18:16'!
groupList: anOrderedCollection
	"Sets the user group list."

	groupList := anOrderedCollection.! !

!User methodsFor: 'getters' stamp: 'RFG 5/3/2013 15:32'!
id
	"Returns the user ID."

	^id.! !

!User methodsFor: 'setters' stamp: 'RFG 5/3/2013 15:17'!
id: anID
	"comment stating purpose of message"

	id := anID.! !

!User methodsFor: 'getters' stamp: 'RFG 5/3/2013 15:32'!
name
	"Returns the user's name."

	^name.! !

!User methodsFor: 'setters' stamp: 'RFG 5/3/2013 15:17'!
name: aName
	"comment stating purpose of message"

	name := aName.! !

!User methodsFor: 'init' stamp: 'AP 5/10/2013 13:44'!
new

	! !
